unit Ccp_demo;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Tbar1, StdCtrls, extCtrls, Buttons, DBCtrls, DB,
  DBTables, Grids, DBGrids, Menus, TabNotBk, Spin,clipBrd, Mask;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit3: TMenuItem;
    Paste1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    TabbedNotebook1: TTabbedNotebook;
    Label2: TLabel;
    Edit1: TEdit;
    DBGrid1: TDBGrid;
    StringGrid1: TStringGrid;
    DBImage1: TDBImage;
    Memo1: TMemo;
    myTBar: TcwClpBoardBar;
    butCut: TcwClpBoardButton;
    butCopy: TcwClpBoardButton;
    butPaste: TcwClpBoardButton;
    Button1: TButton;
    DBGrid2: TDBGrid;
    Edit4: TEdit;
    Memo2: TMemo;
    DBImage2: TDBImage;
    Bevel1: TBevel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Bevel2: TBevel;
    SpinEdit1: TSpinEdit;
    toolBar2: TcwToolBar;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    Button3: TButton;
    Bevel3: TBevel;
    Label1: TLabel;
    Button2: TButton;
    A: TLabel;
    B: TLabel;
    butHelp: TBitBtn;
    Button4: TButton;
    Button5: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Button6: TButton;
    Memo3: TMemo;
    lblAuto: TLabel;
    Bevel4: TBevel;
    SpeedButton1: TSpeedButton;
    Memo4: TMemo;
    DBEdit1: TDBEdit;
    SpeedButton2: TSpeedButton;
    procedure Paste1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure DBImage1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure butHelpClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
   procedure AppIdle(Sender: TObject; var Done: Boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Paste1Click(Sender: TObject);
begin
 butPaste.Click;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.Cut1Click(Sender: TObject);
begin
 butCut.Click;
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
 butCopy.Click;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
 messageDlg('This button is added and programmed by the developer',
       mtInformation,[mbOK],0);
end;

procedure TForm1.DBImage1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (shift = [ssShift]) and ( Key = VK_Delete) then begin
 Key := 0; {Prevent windows from seeing it}
 {butCut.Click;}
end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 butCut.Visible   := Not butCut.Visible;
 butCopy.Visible  := butCut.Visible;
 butPaste.Visible := butCut.Visible;

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 messageDlg('Button added by developer',mtInformation,[mbOK],0);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 dbImage2.Stretch := Not dbImage2.Stretch;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
 myTBar.Dock := tdTop;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  myTBar.Dock := tdBottom;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
 myTBar.Dock := tdLeft;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
  myTBar.Dock := tdRight;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
 toolBar2.width := SpinEdit1.value;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 toolBar2.AutoSizeButtons := Not ToolBar2.AutosizeButtons;
 if toolBar2.AutoSizeButtons then
  A.caption := 'On'
 else
  A.caption := 'Off'
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 toolBar2.KeepSquare := Not ToolBar2.KeepSquare;
  if toolBar2.KeepSquare then
   B.caption := 'On'
 else
  B.caption := 'Off'
end;

procedure TForm1.butHelpClick(Sender: TObject);
begin
 messageDlg('The Edit menu items are linked to these buttons'+#13#10+
            'If you make them invisible you will find that they'+ #13#10+
            'still work. In other words they can be used as hidden components'+#13#10+
            'if buttons are not wanted in the GUI',mtInformation,[mbOK],0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 butHelp.caption := '';
 Application.OnIdle := AppIdle;
end;

procedure TForm1.AppIdle(Sender: TObject; var Done: Boolean);
Begin
Try
 butCut.setEnabledState;
 butCopy.setEnabledState;
 butPaste.setEnabledState;
 myTBar.setEnabledState;
except
 on E:Exception do
  messageDlg(E.Message,mtError,[mbOK],0);
end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 DataSource1.AutoEdit := NOT DataSource1.AutoEdit;
 if DataSource1.AutoEdit then
  lblAuto.Caption := 'On'
 else
  lblAuto.Caption := 'Off'
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 Table1.Edit;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 Table1.Post;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Application.HelpFile := 'CWC.HLP';
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

end.
